var express = require('express')
var bodyParser = require('body-parser');
var app = express();
app.use(bodyParser.json())
var gamedata = require("./public/items.json");

const itemcount = 20;
const games = {}
app.use('/', express.static('public'))

app.post('/startgame', function(req, res) {

  var startCallback = function (){
    res.send(JSON.stringify(games[req.body.gameid].items));
  }

  console.log(JSON.stringify(req.body));
  res.header("Content-Type",'application/json');
  if(games[req.body.gameid]==undefined){
    console.log("START");
    const shuffled = gamedata.sort(() => 0.5 - Math.random());
    let selected = shuffled.slice(0, itemcount);

    console.log("pl1 content");
    games[req.body.gameid] = { players : 1, pl1name : req.body.name, pl1role : req.body.role, items : JSON.parse(JSON.stringify(selected)), processed : 0 } ;

    var _flagCheck = setInterval(function() {
        if (games[req.body.gameid].players==2) {
            clearInterval(_flagCheck);
            startCallback(); // the function to run once all flags are true
        }
    }, 100); // interval set at 100 milliseconds
  }
  else if(games[req.body.gameid]!=undefined && games[req.body.gameid].players!=undefined && games[req.body.gameid].players==1){
    console.log("pl2 content");

    games[req.body.gameid] = {...games[req.body.gameid], players : 2, pl2name : req.body.name, pl2role : req.body.role, pl1joy : 0, pl2joy : 0, pl1money : 0, pl2money : 0 } ;

    for(var i=0; i < games[req.body.gameid].items.length; i++) {
      if (Math.random() >= 0.5){
        games[req.body.gameid].items[i].description = games[req.body.gameid].items[i].description.replace(/XXX/g, games[req.body.gameid].pl1name);
        games[req.body.gameid].items[i].description = games[req.body.gameid].items[i].description.replace(/YYY/g, games[req.body.gameid].pl2name);
      }
     else{
       games[req.body.gameid].items[i].description = games[req.body.gameid].items[i].description.replace(/XXX/g, games[req.body.gameid].pl2name);
       games[req.body.gameid].items[i].description = games[req.body.gameid].items[i].description.replace(/YYY/g, games[req.body.gameid].pl1name);
     }
    }
    console.log(games[req.body.gameid]);

    res.send(JSON.stringify(games[req.body.gameid].items));
  }
  else{
//    res.send('error');
res.send(JSON.stringify(gamedata));
  }
  //console.log(games);

});
app.post('/wantit', function(req, res) {
  selectaction(req,res,'w');
});
app.post('/youcan', function(req, res) {
  selectaction(req,res,'y');
});
app.post('/ridof', function(req, res) {
  selectaction(req,res,'r');
});

function selectaction(req, res, type) {

  var player = 'pl2';
  var otherPlayer = 'pl1';
  var otherplayername = '';
  var joyName = '';
  var otherJoyName = '';
  var moneyName = '';
  var roleName = '';
  if(games[req.body.gameid].pl1name == req.body.name){
    player = 'pl1';
    otherPlayer = 'pl2';
    otherplayername = games[req.body.gameid].pl2name;
    joyName = 'pl1joy';
    otherJoyName = 'pl2joy';
    moneyName = 'pl1money';
    roleName = 'pl1role';
  } else {
    otherplayername = games[req.body.gameid].pl1name;
    joyName = 'pl2joy';
    otherJoyName = 'pl1joy';
    moneyName = 'pl2money';
    roleName = 'pl2role';
  }

  games[req.body.gameid][req.body.item.id] = {...games[req.body.gameid][req.body.item.id],[player]:type};

  res.header("Content-Type",'application/json');
  console.log(req.body);
  console.log(games[req.body.gameid]);

  var theCallback = function (){
    var message = '';
    if((type=='r' && games[req.body.gameid][req.body.item.id][otherPlayer]=='y') ||(type=='y' && games[req.body.gameid][req.body.item.id][otherPlayer]=='r') ||(type=='r' && games[req.body.gameid][req.body.item.id][otherPlayer]=='r') || (type=='w' && games[req.body.gameid][req.body.item.id][otherPlayer]=='w') || (type=='y' && games[req.body.gameid][req.body.item.id][otherPlayer]=='y')){
      if(req.body.item.value<10){
        var message = 'The item was thrown away.';
      }
      else{
        var message = 'The item was sold, and you’ll split the money.';
        games[req.body.gameid][moneyName] = games[req.body.gameid][moneyName]+(req.body.item.value / 2);

      }
    }
    if(type=='w' && games[req.body.gameid][req.body.item.id][otherPlayer]=='y'){
      var message = 'You decided that '+req.body.name+' gets the item.';
      games[req.body.gameid][joyName] = games[req.body.gameid][joyName]+(req.body.item[games[req.body.gameid][roleName]]);
    }
    if(type=='y' && games[req.body.gameid][req.body.item.id][otherPlayer]=='w'){
      var message = 'You decided that '+otherplayername+' gets the item.';
    }
    if(type=='w' && games[req.body.gameid][req.body.item.id][otherPlayer]=='r'){
      var message = 'You decided that '+req.body.name+' gets the item.';
      games[req.body.gameid][joyName] = games[req.body.gameid][joyName]+(req.body.item[games[req.body.gameid][roleName]]);
    }
    if(type=='r' && games[req.body.gameid][req.body.item.id][otherPlayer]=='w'){
      var message = 'You decided that '+otherplayername+' gets the item.';
    }

    console.log(itemcount);
    console.log(games[req.body.gameid].processed);
    if(games[req.body.gameid].processed<itemcount){
      res.send({lastitem:false, message:message, joy:games[req.body.gameid][joyName], money:games[req.body.gameid][moneyName]});
    } else{

      var finalmessage = '';


    if(games[req.body.gameid][joyName] > games[req.body.gameid][otherJoyName]){
        finalmessage = 'You beat your ex-partner in scoring joy from the material ruins of your relationship.';
    }
    else if(games[req.body.gameid][joyName] < games[req.body.gameid][otherJoyName]){
    finalmessage = 'Your ex-partner beats you in scoring joy from the material ruins of your relationship.';
    }
    else{
    finalmessage = 'You and your ex-partner were able to score the exact same amount of joy from the material ruins of your relationship.';
    }

      res.send({lastitem:true, message:message, finalmessage:finalmessage, joy:games[req.body.gameid][joyName], money:games[req.body.gameid][moneyName]});
    }
  }

  if (games[req.body.gameid][req.body.item.id][otherPlayer]==undefined) {
      games[req.body.gameid].processed+=1;
    }
  var _flagCheck = setInterval(function() {
      if (games[req.body.gameid][req.body.item.id][otherPlayer]!=undefined) {
          clearInterval(_flagCheck);
          theCallback(); // the function to run once all flags are true
      }
  }, 100); // interval set at 100 milliseconds



}

//app.listen(process.env.PORT || 80, () => console.log('Example app listening on port 3000!'))
app.listen(3000, () => console.log('Example app listening on port 3000!'))
